#define _XOPEN_SOURCE 501
#include <unistd.h>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <sqlite3.h>
#include "auth.h"

//#define __CONSOLE__ //    

char *qs = NULL;
char* get_qs(){
	char *m, *tmpbuf;
	if((m = getenv("REQUEST_METHOD")) && strcasecmp(m, "POST") == 0){
		tmpbuf = (char*)calloc(2048, 1);
		fgets(tmpbuf, 2048, stdin);
		qs = strdup(tmpbuf);
		free(tmpbuf);
	}
	else 
#ifdef __CONSOLE__ 
		if( (tmpbuf = getenv("QUERY_STRING")) )
			qs = strdup(tmpbuf);
#else
	die(NO_QS);
#endif
	if(qs && strlen(qs) < 1)
		die(NO_QS);
	return qs;
}

char* get_qs_param(char *param){
	char *tok, *val, *par, *str, *ret = NULL;
	if(!qs) return NULL;
	str = strdup(qs);
	tok = strtok(str, "& \n");
	do{
		if((val = strchr(tok, '=')) == NULL) continue;
		*val++ = '\0';
		par = tok;
		if(strcasecmp(par, param)==0){
			if( strlen(val) > 0 )
				ret = strdup(val);
			break;
		}
	}while((tok = strtok(NULL, "& \n"))!=NULL);
	free(str);
	return ret;
}

char *SQLbuf = NULL;
int callback(void *NotUsed, int argc, char **argv, char **azColName){
	if(!*argv) return 1;
	SQLbuf = strdup(*argv);
	return 0;
}

char *SQLexec(char *q_str){
	sqlite3 *db;
	char *zErrMsg = NULL, *ret = NULL;
	int rc = sqlite3_open("user-pass", &db);
	if(rc){ sqlite3_close(db); die(NO_DB);}
	if(SQLbuf){ free(SQLbuf); SQLbuf = NULL;}
	rc = sqlite3_exec(db, q_str, callback, NULL, &zErrMsg);
	if(rc){
		fprintf(stderr, "SQL error: %s\n", zErrMsg);
		//die(SQL_ERR);
	}
	else if(SQLbuf)
		ret = strdup(SQLbuf);
	sqlite3_close(db);
	return ret;
}

char *get_passwd(char *login, int *level){
	char *q_str = (char*)calloc(512, 1), *ret=NULL, *tmp;
	snprintf(q_str, 512, "select pass from users where login=\"%s\";", login);
	ret = SQLexec(q_str);
	snprintf(q_str, 512, "select level from users where login=\"%s\";", login);
	if( !(tmp = SQLexec(q_str)) ) *level = 0;
	else *level = atoi(tmp);
	free(q_str);
	free(tmp);
	return ret;
}

void insert2db(char *id, char *key, int level){
	char *q_str = (char*)calloc(512, 1);
	snprintf(q_str, 512, "delete from keyid where time < julianday('now')-1;");
	SQLexec(q_str);
	snprintf(q_str, 512, "insert into keyid values(\"%s\",\"%s\",%d,julianday('now'));", id, key, level);
	SQLexec(q_str);
}

char *sha(char *str, char *salt){
	char *tmp = crypt(str, salt);
	return strdup(tmp);
}

char *getpath(char *url){
	char *ptr, *ptr1;
	ptr = strchr(url, '/');
	if(!ptr) return NULL;
	ptr1 = strchr(ptr+1, '/');
	if(!ptr1) return NULL;
	ptr = strchr(ptr1+1, '/');
	if(!ptr){
		ptr = (char*)calloc(2,1);
		*ptr = '/';
	}
	return ptr;
}

int main(int argc, char **argv){
	char *IP, *URL, *id, *login, *pass_raw, *pass_ori, *pass, *key, *salt;
	int level;
	printf("Content-type: text/html\n\n");
	salt = calloc(128, 1);
	IP = getenv("REMOTE_ADDR");
	if(!IP) die(BAD_IP);
	if( !get_qs() ) die(NO_QS);
	if(!(URL = get_qs_param("URL"))) die(BAD_URL);
	if(!(login = get_qs_param("login"))) die(NO_LOGIN);
	if(!(pass_raw = get_qs_param("passwd"))) die(NO_PASSWD);
	pass = sha(pass_raw, "$6$pass-enc$");
	free(pass_raw);
	if( !(pass_ori = get_passwd(login, &level)) ) die(WRONG_PASSWD);
	if(strcmp(pass_ori, pass)) die(WRONG_PASSWD);
	srand(time(NULL));
	snprintf(salt, 128, "$5$%s$", IP);
	id = sha(URL, salt);
	id = strrchr(id, '$') + 1;
	snprintf(salt, 128, "$5$.%d.$", rand());
	key = sha(id, salt);
	key = strrchr(key, '$') + 1;
	free(salt);
	insert2db(id, key, level);
	printf("KEY=%s; path=%s\n", key, getpath(URL));
	return(0);
}

